let contextMenu = null;

/**
 * Provide a context menu.
 *
 * This menu is trigger by 'context' or called directly
 *
 * @param ev
 *   Triggering event for positional purpose
 * @param targetId
 *   TODO needs description
 * @param actions
 *   List of possible actions presented to the user.
 */
let rightClickMenu = function (ev, targetId, actions) {
    // if (contextMenu) {
    //     contextMenu.remove();
    // }

    contextMenu = document.createElement('ul');
    contextMenu.classList.add('dropdown-menu');
    for (let i = 0; i < actions.length; i++) {
        let item = document.createElement('li');
        if (actions[i].type == 'separator') {
            item.classList.add('divider');
        } else {
            let link = document.createElement('a');
            link.href = '#';
            link.tabIndex = -1;
            link.innerHTML = actions[i].label;
            link.dataset['targetId'] = targetId;
            link.dataset['id'] = actions[i].id;
            link.dataset['type'] = actions[i].type;

            if (actions[i].api) {
                link.dataset['api'] = actions[i].api;
            }

            if (actions[i].target) {
                link.dataset['target'] = actions[i].target;
            }

            let hasView = [
                'view',
                'edit',
                'execute-fulltext',
                'submit-fulltext',
                'search-text'
            ];
            if (false !== hasView.indexOf(actions[i].type)) {
                link.dataset['view'] = actions[i].view;
            }
            if (actions[i].type == 'tree') {
                link.dataset['action'] = actions[i].action;
            }
            item.appendChild(link);

            link.onclick = function (ev) {
                ev.preventDefault();

                let action = {
                    id: this.dataset.id,
                    type: this.dataset.type,
                    targetId: this.dataset.targetId
                };
                if (this.dataset.api) {
                    action.api = this.dataset.api;
                }
                if (this.dataset.target) {
                    action.target = this.dataset.target;
                }
                if (false !== hasView.indexOf(action.type)) {
                    action.view = this.dataset.view;
                }
                if (action.type == 'tree') {
                    action.action = this.dataset.action;
                }
                if (contextMenu) {
                    contextMenu.remove();
                }

                // executeAction(action);
                get_server_response(action.view);
            };
        }
        contextMenu.appendChild(item);
        setTimeout(()=> contextMenu.remove(), 4000);
    }

    const x = ev.pageX;
    const y = ev.pageY;

    contextMenu.style.top = y + "px";
    contextMenu.style.left = x + "px";
    contextMenu.style.display = "block";
    document.body.appendChild(contextMenu);
};

function contextMenuHandler(ev) {
    if (contextMenu) {
        contextMenu.remove();
    }
    console.log('contextMenuHandler');
    let target = ev.target;
    // FIXME ... does not work ; in console it works on target
    // Find a self or parent with a dataset-context
    // let parent = target.closest('*[dataset-context]');
    // console.info(target, target.closest('*[dataset-context]'));
    // debugger;
    // if (parent && parent !== target) {
    //     console.warn("Getting context from (grand)parent.");
    //     target = parent;
    // }
    // if (!target.classList.contains('context')) return false;
    // dataset.context
    let actions;
    if (target.dataset && target.dataset.context) {
        actions = JSON.parse(target.dataset.context);
    };

    const targetId = target.id;

    // TODO: remove this auto actions
    if (!actions) {
        return true;
    }
    console.log(targetId, actions);
    rightClickMenu(ev, targetId, actions);
    return false;
}
document.oncontextmenu = contextMenuHandler;